/*
 *  Demo of COSS Relationship Service
 *  Copyright (C) 1998 Karel Gardas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 *  or to my private e-mail:
 *                 gardask@alpha.inf.upol.cz
 */


#include "Person.h"

#ifndef __Person_impl_h__
#define __Person_impl_h__

class Person_impl : virtual public Person_skel
{
  CORBA::Long apid;
  CORBA::Long ayear;
  CORBA::Long amonth;
  CORBA::Long aday;
  char* afirst_name;
  char* asurname;
public:
  Person_impl ();
  Person_impl (CORBA::Object_ptr obj);
  Person_impl (CORBA::Long xpid, CORBA::Long xyear, 
	       CORBA::Long xmonth, CORBA::Long xday);
  Person_impl (CORBA::Long xpid, CORBA::Long xyear, CORBA::Long xmonth, 
	       CORBA::Long xday, const char* xfirst, const char* xsur);
  virtual CORBA::Boolean _save_object ();
  virtual CORBA::Long pid ();
  virtual CORBA::Long year ();
  virtual CORBA::Long month ();
  virtual CORBA::Long day ();
  virtual char* first_name ();
  virtual void first_name (const char* value);
  virtual char* surname ();
  virtual void surname (const char* value);

  virtual void destroy ();
};


class PersonFactory_impl : virtual public PersonFactory_skel
{
public:
  PersonFactory_impl ();
  Person_ptr create_noname();
  Person_ptr create (CORBA::Long p, CORBA::Long y, CORBA::Long m, 
		     CORBA::Long d);
  Person_ptr create_with_name (CORBA::Long p, CORBA::Long y, CORBA::Long m,
			       CORBA::Long d, const char* f, const char* s);
  void destroy ();
};


class PersonLoader : virtual public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


#endif
