// -*- c++ -*-
/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#ifndef __BASIC_SEQ_H__
#define __BASIC_SEQ_H__


CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::CharWrapper> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::CharWrapper> &s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::BooleanWrapper> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::BooleanWrapper> &s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::OctetWrapper> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::OctetWrapper> &s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::UShort> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::UShort> &s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::ULong> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::ULong> &s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::Short> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::Short> &s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::Long> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::Long> &s );

CORBA::Boolean operator<<=( CORBA::Any &_a,
			    const SequenceTmpl<CORBA::LongLong> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a,
			    SequenceTmpl<CORBA::LongLong> &_s );

CORBA::Boolean operator<<=( CORBA::Any &_a,
			    const SequenceTmpl<CORBA::ULongLong> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a,
			    SequenceTmpl<CORBA::ULongLong> &_s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::Float> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::Float> &s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::Double> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::Double> &s );

CORBA::Boolean operator<<=( CORBA::Any &_a,
			    const SequenceTmpl<CORBA::LongDouble> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a,
			    SequenceTmpl<CORBA::LongDouble> &_s );

CORBA::Boolean operator<<=( CORBA::Any &_a,
			    const SequenceTmpl<CORBA::WCharWrapper> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a,
			    SequenceTmpl<CORBA::WCharWrapper> &_s );

CORBA::Boolean operator<<=( CORBA::Any &_a,
			    const SequenceTmpl<CORBA::WString_var> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a,
			    SequenceTmpl<CORBA::WString_var> &_s );

CORBA::Boolean operator<<=( CORBA::Any &a,
			    const SequenceTmpl<CORBA::String_var> &s );
CORBA::Boolean operator>>=( const CORBA::Any &a,
			    SequenceTmpl<CORBA::String_var> &s );

CORBA::Boolean operator<<=( CORBA::Any &_a,
			    const SequenceTmpl<CORBA::Object_var> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a,
			    SequenceTmpl<CORBA::Object_var> &_s );

#endif
