/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__NAMING_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __NAMING_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL CosNaming {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosNaming)


typedef char* Istring;
typedef CORBA::String_var Istring_var;
typedef CORBA::String_out Istring_out;

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_Istring;

struct NameComponent {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  NameComponent();
  ~NameComponent();
  NameComponent( const NameComponent& s );
  NameComponent& operator=( const NameComponent& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS
  Istring_var id;
  Istring_var kind;
};

typedef TVarVar<NameComponent> NameComponent_var;
typedef NameComponent_var NameComponent_out;

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_NameComponent;

typedef SequenceTmpl<NameComponent> Name;
#ifdef _WINDOWS
static Name _dummy_Name;
#endif
typedef TSeqVar<SequenceTmpl<NameComponent> > Name_var;
typedef Name_var Name_out;

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_Name;

enum BindingType {
  nobject = 0,
  ncontext
};

typedef BindingType& BindingType_out;

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_BindingType;

struct Binding {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  Binding();
  ~Binding();
  Binding( const Binding& s );
  Binding& operator=( const Binding& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS
  Name binding_name;
  BindingType binding_type;
};

typedef TVarVar<Binding> Binding_var;
typedef Binding_var Binding_out;

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_Binding;

typedef SequenceTmpl<Binding> BindingList;
#ifdef _WINDOWS
static BindingList _dummy_BindingList;
#endif
typedef TSeqVar<SequenceTmpl<Binding> > BindingList_var;
typedef BindingList_var BindingList_out;

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_BindingList;

class NamingContext;
typedef NamingContext *NamingContext_ptr;
typedef NamingContext_ptr NamingContextRef;
typedef ObjVar<NamingContext> NamingContext_var;
typedef NamingContext_var NamingContext_out;

class BindingIterator;
typedef BindingIterator *BindingIterator_ptr;
typedef BindingIterator_ptr BindingIteratorRef;
typedef ObjVar<BindingIterator> BindingIterator_var;
typedef BindingIterator_var BindingIterator_out;


// Common definitions for interface NamingContext
class NamingContext : virtual public CORBA::Object
{
  public:
    virtual ~NamingContext();
    static NamingContext_ptr _duplicate( NamingContext_ptr obj );
    static NamingContext_ptr _narrow( CORBA::Object_ptr obj );
    static NamingContext_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    enum NotFoundReason {
      missing_node = 0,
      not_context,
      not_object
    };

    typedef NotFoundReason& NotFoundReason_out;

    static CORBA::TypeCodeConst _tc_NotFoundReason;

    struct NotFound : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      NotFound();
      ~NotFound();
      NotFound( const NotFound& s );
      NotFound& operator=( const NotFound& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static NotFound *_narrow( CORBA::Exception *ex );
      NotFoundReason why;
      Name rest_of_name;
    };

    typedef ExceptVar<NotFound> NotFound_var;
    typedef NotFound_var NotFound_out;

    static CORBA::TypeCodeConst _tc_NotFound;

    struct CannotProceed : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      CannotProceed();
      ~CannotProceed();
      CannotProceed( const CannotProceed& s );
      CannotProceed& operator=( const CannotProceed& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static CannotProceed *_narrow( CORBA::Exception *ex );
      ::CosNaming::NamingContext_var cxt;
      Name rest_of_name;
    };

    typedef ExceptVar<CannotProceed> CannotProceed_var;
    typedef CannotProceed_var CannotProceed_out;

    static CORBA::TypeCodeConst _tc_CannotProceed;

    struct InvalidName : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      InvalidName();
      ~InvalidName();
      InvalidName( const InvalidName& s );
      InvalidName& operator=( const InvalidName& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static InvalidName *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<InvalidName> InvalidName_var;
    typedef InvalidName_var InvalidName_out;

    static CORBA::TypeCodeConst _tc_InvalidName;

    struct AlreadyBound : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      AlreadyBound();
      ~AlreadyBound();
      AlreadyBound( const AlreadyBound& s );
      AlreadyBound& operator=( const AlreadyBound& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static AlreadyBound *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<AlreadyBound> AlreadyBound_var;
    typedef AlreadyBound_var AlreadyBound_out;

    static CORBA::TypeCodeConst _tc_AlreadyBound;

    struct NotEmpty : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      NotEmpty();
      ~NotEmpty();
      NotEmpty( const NotEmpty& s );
      NotEmpty& operator=( const NotEmpty& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static NotEmpty *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<NotEmpty> NotEmpty_var;
    typedef NotEmpty_var NotEmpty_out;

    static CORBA::TypeCodeConst _tc_NotEmpty;

    virtual void bind( const Name& n, CORBA::Object_ptr obj ) = 0;
    virtual void rebind( const Name& n, CORBA::Object_ptr obj ) = 0;
    virtual void bind_context( const Name& n, ::CosNaming::NamingContext_ptr nc ) = 0;
    virtual void rebind_context( const Name& n, ::CosNaming::NamingContext_ptr nc ) = 0;
    virtual CORBA::Object_ptr resolve( const Name& n ) = 0;
    virtual void unbind( const Name& n ) = 0;
    virtual ::CosNaming::NamingContext_ptr new_context() = 0;
    virtual ::CosNaming::NamingContext_ptr bind_new_context( const Name& n ) = 0;
    virtual void destroy() = 0;
    virtual void list( CORBA::ULong how_many, BindingList*& bl, BindingIterator_ptr& bi ) = 0;
  protected:
    NamingContext() {};
  private:
    NamingContext( const NamingContext& );
    void operator=( const NamingContext& );
};

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_NamingContext;

// Stub for interface NamingContext
class NamingContext_stub : virtual public NamingContext
{
  public:
    virtual ~NamingContext_stub();
    void bind( const Name& n, CORBA::Object_ptr obj );
    void rebind( const Name& n, CORBA::Object_ptr obj );
    void bind_context( const Name& n, ::CosNaming::NamingContext_ptr nc );
    void rebind_context( const Name& n, ::CosNaming::NamingContext_ptr nc );
    CORBA::Object_ptr resolve( const Name& n );
    void unbind( const Name& n );
    ::CosNaming::NamingContext_ptr new_context();
    ::CosNaming::NamingContext_ptr bind_new_context( const Name& n );
    void destroy();
    void list( CORBA::ULong how_many, BindingList*& bl, BindingIterator_ptr& bi );
  private:
    void operator=( const NamingContext_stub& );
};

class NamingContext_skel :
  virtual public MethodDispatcher,
  virtual public NamingContext
{
  public:
    NamingContext_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~NamingContext_skel();
    NamingContext_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    NamingContext_ptr _this();

};


// Common definitions for interface BindingIterator
class BindingIterator : virtual public CORBA::Object
{
  public:
    virtual ~BindingIterator();
    static BindingIterator_ptr _duplicate( BindingIterator_ptr obj );
    static BindingIterator_ptr _narrow( CORBA::Object_ptr obj );
    static BindingIterator_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual CORBA::Boolean next_one( ::CosNaming::Binding*& b ) = 0;
    virtual CORBA::Boolean next_n( CORBA::ULong how_many, BindingList*& bl ) = 0;
    virtual void destroy() = 0;
  protected:
    BindingIterator() {};
  private:
    BindingIterator( const BindingIterator& );
    void operator=( const BindingIterator& );
};

MICO_EXPORT_VAR_DECL CORBA::TypeCodeConst _tc_BindingIterator;

// Stub for interface BindingIterator
class BindingIterator_stub : virtual public BindingIterator
{
  public:
    virtual ~BindingIterator_stub();
    CORBA::Boolean next_one( ::CosNaming::Binding*& b );
    CORBA::Boolean next_n( CORBA::ULong how_many, BindingList*& bl );
    void destroy();
  private:
    void operator=( const BindingIterator_stub& );
};

class BindingIterator_skel :
  virtual public MethodDispatcher,
  virtual public BindingIterator
{
  public:
    BindingIterator_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~BindingIterator_skel();
    BindingIterator_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    BindingIterator_ptr _this();

};

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosNaming)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif



#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &_a, const ::CosNaming::NameComponent &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::CosNaming::NameComponent &_s );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::BindingType &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::BindingType &e );

CORBA::Boolean operator<<=( CORBA::Any &_a, const ::CosNaming::Binding &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::CosNaming::Binding &_s );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::NotFoundReason &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::NotFoundReason &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::NotFound &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::NotFound &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::CannotProceed &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::CannotProceed &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::InvalidName &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::InvalidName &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::AlreadyBound &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::AlreadyBound &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::NotEmpty &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::NotEmpty &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosNaming::NamingContext_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosNaming::NamingContext_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosNaming::BindingIterator_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosNaming::BindingIterator_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &_a, const SequenceTmpl<CosNaming::NameComponent> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, SequenceTmpl<CosNaming::NameComponent> &_s );

CORBA::Boolean operator<<=( CORBA::Any &_a, const SequenceTmpl<CosNaming::Binding> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, SequenceTmpl<CosNaming::Binding> &_s );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
