// -*- c++ -*-

/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__POA_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __POA_H__

#if 0
#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif
#endif

#ifdef MICO_IN_GENERATED_CODE
#include <mico/ir.h>
#else
#define MICO_IN_GENERATED_CODE
#include <mico/ir.h>
#undef MICO_IN_GENERATED_CODE
#endif

#ifdef MICO_IN_GENERATED_CODE
#include <mico/policy.h>
#else
#define MICO_IN_GENERATED_CODE
#include <mico/policy.h>
#undef MICO_IN_GENERATED_CODE
#endif

#ifdef MICO_IN_GENERATED_CODE
#include <mico/current.h>
#else
#define MICO_IN_GENERATED_CODE
#include <mico/current.h>
#undef MICO_IN_GENERATED_CODE
#endif

#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL PortableServer {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_PortableServer)


typedef SequenceTmpl<CORBA::OctetWrapper> ObjectId;
#ifdef _WINDOWS
static ObjectId _dummy_ObjectId;
#endif
typedef TSeqVar<SequenceTmpl<CORBA::OctetWrapper> > ObjectId_var;
typedef ObjectId_var ObjectId_out;

// begin-idl-hack
class ServantBase;
typedef ServantBase * Servant;

class POA;
typedef POA *__POA_ptr;

class ServantBase
{
public:
  virtual ~ServantBase ();
  ServantBase & operator= (const ServantBase &);
  virtual __POA_ptr _default_POA();
  
  // begin-mico-extension
  virtual bool _is_a (const char *);
  virtual void * _narrow_helper (const char *);
  virtual void invoke (CORBA::ServerRequest_ptr) = 0;
  virtual CORBA::RepositoryId _primary_interface (const ObjectId &,
						  __POA_ptr) = 0;
  __POA_ptr _activated_in ();
  void _activated_in (__POA_ptr);
  // end-mico-extension

protected:
  ServantBase ();
  ServantBase (const ServantBase &);
  __POA_ptr _my_poa;
};

class DynamicImplementation : public virtual ServantBase
{
public:
  virtual ~DynamicImplementation ();
  CORBA::Object_ptr _this ();
  virtual void invoke (CORBA::ServerRequest_ptr) = 0;
  virtual CORBA::RepositoryId _primary_interface (const ObjectId &,
						  __POA_ptr) = 0;
};

MICO_EXPORT_DECL char *     ObjectId_to_string  (const ObjectId &);
MICO_EXPORT_DECL wchar_t *  ObjectId_to_wstring (const ObjectId &);
MICO_EXPORT_DECL ObjectId * string_to_ObjectId  (const char *);
MICO_EXPORT_DECL ObjectId * wstring_to_ObjectId (const wchar_t *);
// end-idl-hack

struct ForwardRequest : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  ForwardRequest();
  ~ForwardRequest();
  ForwardRequest( const ForwardRequest& s );
  ForwardRequest& operator=( const ForwardRequest& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS
  void _throwit() const;
  const char *_repoid() const;
  CORBA::Exception *_clone() const;
  static ForwardRequest *_narrow( CORBA::Exception *ex );
  CORBA::Object_var forward_reference;
};

typedef ExceptVar<ForwardRequest> ForwardRequest_var;
typedef ForwardRequest_var ForwardRequest_out;

enum ThreadPolicyValue {
  ORB_CTRL_MODEL = 0,
  SINGLE_THREAD_MODEL
};

typedef ThreadPolicyValue& ThreadPolicyValue_out;

class ThreadPolicy;
typedef ThreadPolicy *ThreadPolicy_ptr;
typedef ThreadPolicy_ptr ThreadPolicyRef;
typedef ObjVar<ThreadPolicy> ThreadPolicy_var;
typedef ThreadPolicy_var ThreadPolicy_out;


// Common definitions for interface ThreadPolicy
class ThreadPolicy : 
  virtual public ::CORBA::Policy
{
  public:
    virtual ~ThreadPolicy();
    static ThreadPolicy_ptr _duplicate( ThreadPolicy_ptr obj );
    static ThreadPolicy_ptr _narrow( CORBA::Object_ptr obj );
    static ThreadPolicy_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual ThreadPolicyValue value() = 0;
  protected:
    ThreadPolicy() {};
  private:
    ThreadPolicy( const ThreadPolicy& );
    void operator=( const ThreadPolicy& );
};


enum LifespanPolicyValue {
  TRANSIENT = 0,
  PERSISTENT
};

typedef LifespanPolicyValue& LifespanPolicyValue_out;

class LifespanPolicy;
typedef LifespanPolicy *LifespanPolicy_ptr;
typedef LifespanPolicy_ptr LifespanPolicyRef;
typedef ObjVar<LifespanPolicy> LifespanPolicy_var;
typedef LifespanPolicy_var LifespanPolicy_out;


// Common definitions for interface LifespanPolicy
class LifespanPolicy : 
  virtual public ::CORBA::Policy
{
  public:
    virtual ~LifespanPolicy();
    static LifespanPolicy_ptr _duplicate( LifespanPolicy_ptr obj );
    static LifespanPolicy_ptr _narrow( CORBA::Object_ptr obj );
    static LifespanPolicy_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual LifespanPolicyValue value() = 0;
  protected:
    LifespanPolicy() {};
  private:
    LifespanPolicy( const LifespanPolicy& );
    void operator=( const LifespanPolicy& );
};


enum IdUniquenessPolicyValue {
  UNIQUE_ID = 0,
  MULTIPLE_ID
};

typedef IdUniquenessPolicyValue& IdUniquenessPolicyValue_out;

class IdUniquenessPolicy;
typedef IdUniquenessPolicy *IdUniquenessPolicy_ptr;
typedef IdUniquenessPolicy_ptr IdUniquenessPolicyRef;
typedef ObjVar<IdUniquenessPolicy> IdUniquenessPolicy_var;
typedef IdUniquenessPolicy_var IdUniquenessPolicy_out;


// Common definitions for interface IdUniquenessPolicy
class IdUniquenessPolicy : 
  virtual public ::CORBA::Policy
{
  public:
    virtual ~IdUniquenessPolicy();
    static IdUniquenessPolicy_ptr _duplicate( IdUniquenessPolicy_ptr obj );
    static IdUniquenessPolicy_ptr _narrow( CORBA::Object_ptr obj );
    static IdUniquenessPolicy_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual IdUniquenessPolicyValue value() = 0;
  protected:
    IdUniquenessPolicy() {};
  private:
    IdUniquenessPolicy( const IdUniquenessPolicy& );
    void operator=( const IdUniquenessPolicy& );
};


enum IdAssignmentPolicyValue {
  USER_ID = 0,
  SYSTEM_ID
};

typedef IdAssignmentPolicyValue& IdAssignmentPolicyValue_out;

class IdAssignmentPolicy;
typedef IdAssignmentPolicy *IdAssignmentPolicy_ptr;
typedef IdAssignmentPolicy_ptr IdAssignmentPolicyRef;
typedef ObjVar<IdAssignmentPolicy> IdAssignmentPolicy_var;
typedef IdAssignmentPolicy_var IdAssignmentPolicy_out;


// Common definitions for interface IdAssignmentPolicy
class IdAssignmentPolicy : 
  virtual public ::CORBA::Policy
{
  public:
    virtual ~IdAssignmentPolicy();
    static IdAssignmentPolicy_ptr _duplicate( IdAssignmentPolicy_ptr obj );
    static IdAssignmentPolicy_ptr _narrow( CORBA::Object_ptr obj );
    static IdAssignmentPolicy_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual IdAssignmentPolicyValue value() = 0;
  protected:
    IdAssignmentPolicy() {};
  private:
    IdAssignmentPolicy( const IdAssignmentPolicy& );
    void operator=( const IdAssignmentPolicy& );
};


enum ImplicitActivationPolicyValue {
  IMPLICIT_ACTIVATION = 0,
  NO_IMPLICIT_ACTIVATION
};

typedef ImplicitActivationPolicyValue& ImplicitActivationPolicyValue_out;

class ImplicitActivationPolicy;
typedef ImplicitActivationPolicy *ImplicitActivationPolicy_ptr;
typedef ImplicitActivationPolicy_ptr ImplicitActivationPolicyRef;
typedef ObjVar<ImplicitActivationPolicy> ImplicitActivationPolicy_var;
typedef ImplicitActivationPolicy_var ImplicitActivationPolicy_out;


// Common definitions for interface ImplicitActivationPolicy
class ImplicitActivationPolicy : 
  virtual public ::CORBA::Policy
{
  public:
    virtual ~ImplicitActivationPolicy();
    static ImplicitActivationPolicy_ptr _duplicate( ImplicitActivationPolicy_ptr obj );
    static ImplicitActivationPolicy_ptr _narrow( CORBA::Object_ptr obj );
    static ImplicitActivationPolicy_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual ImplicitActivationPolicyValue value() = 0;
  protected:
    ImplicitActivationPolicy() {};
  private:
    ImplicitActivationPolicy( const ImplicitActivationPolicy& );
    void operator=( const ImplicitActivationPolicy& );
};


enum ServantRetentionPolicyValue {
  RETAIN = 0,
  NON_RETAIN
};

typedef ServantRetentionPolicyValue& ServantRetentionPolicyValue_out;

class ServantRetentionPolicy;
typedef ServantRetentionPolicy *ServantRetentionPolicy_ptr;
typedef ServantRetentionPolicy_ptr ServantRetentionPolicyRef;
typedef ObjVar<ServantRetentionPolicy> ServantRetentionPolicy_var;
typedef ServantRetentionPolicy_var ServantRetentionPolicy_out;


// Common definitions for interface ServantRetentionPolicy
class ServantRetentionPolicy : 
  virtual public ::CORBA::Policy
{
  public:
    virtual ~ServantRetentionPolicy();
    static ServantRetentionPolicy_ptr _duplicate( ServantRetentionPolicy_ptr obj );
    static ServantRetentionPolicy_ptr _narrow( CORBA::Object_ptr obj );
    static ServantRetentionPolicy_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual ServantRetentionPolicyValue value() = 0;
  protected:
    ServantRetentionPolicy() {};
  private:
    ServantRetentionPolicy( const ServantRetentionPolicy& );
    void operator=( const ServantRetentionPolicy& );
};


enum RequestProcessingPolicyValue {
  USE_ACTIVE_OBJECT_MAP_ONLY = 0,
  USE_DEFAULT_SERVANT,
  USE_SERVANT_MANAGER
};

typedef RequestProcessingPolicyValue& RequestProcessingPolicyValue_out;

class RequestProcessingPolicy;
typedef RequestProcessingPolicy *RequestProcessingPolicy_ptr;
typedef RequestProcessingPolicy_ptr RequestProcessingPolicyRef;
typedef ObjVar<RequestProcessingPolicy> RequestProcessingPolicy_var;
typedef RequestProcessingPolicy_var RequestProcessingPolicy_out;


// Common definitions for interface RequestProcessingPolicy
class RequestProcessingPolicy : 
  virtual public ::CORBA::Policy
{
  public:
    virtual ~RequestProcessingPolicy();
    static RequestProcessingPolicy_ptr _duplicate( RequestProcessingPolicy_ptr obj );
    static RequestProcessingPolicy_ptr _narrow( CORBA::Object_ptr obj );
    static RequestProcessingPolicy_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual RequestProcessingPolicyValue value() = 0;
  protected:
    RequestProcessingPolicy() {};
  private:
    RequestProcessingPolicy( const RequestProcessingPolicy& );
    void operator=( const RequestProcessingPolicy& );
};


class POAManager;
typedef POAManager *POAManager_ptr;
typedef POAManager_ptr POAManagerRef;
typedef ObjVar<POAManager> POAManager_var;
typedef POAManager_var POAManager_out;


// Common definitions for interface POAManager
class POAManager : virtual public CORBA::Object
{
  public:
    virtual ~POAManager();
    static POAManager_ptr _duplicate( POAManager_ptr obj );
    static POAManager_ptr _narrow( CORBA::Object_ptr obj );
    static POAManager_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    // begin-idl-hack
    // begin-mico-extension
    enum POAManagerState {
      HOLDING,
      ACTIVE,
      INACTIVE,
      DISCARDING
    };
    virtual POAManagerState state () = 0;
    virtual void add_managed_poa (__POA_ptr) = 0;
    virtual void del_managed_poa (__POA_ptr) = 0;
    // end-mico-extension
    // end-idl-hack

    struct AdapterInactive : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      AdapterInactive();
      ~AdapterInactive();
      AdapterInactive( const AdapterInactive& s );
      AdapterInactive& operator=( const AdapterInactive& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static AdapterInactive *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<AdapterInactive> AdapterInactive_var;
    typedef AdapterInactive_var AdapterInactive_out;

    virtual void activate() = 0;
    virtual void hold_requests( CORBA::Boolean wait_for_completion ) = 0;
    virtual void discard_requests( CORBA::Boolean wait_for_completion ) = 0;
    virtual void deactivate( CORBA::Boolean etherealize_objects, CORBA::Boolean wait_for_completion ) = 0;
  protected:
    POAManager() {};
  private:
    POAManager( const POAManager& );
    void operator=( const POAManager& );
};


class POA;
typedef POA *POA_ptr;
typedef POA_ptr POARef;
typedef ObjVar<POA> POA_var;
typedef POA_var POA_out;

class AdapterActivator;
typedef AdapterActivator *AdapterActivator_ptr;
typedef AdapterActivator_ptr AdapterActivatorRef;
typedef ObjVar<AdapterActivator> AdapterActivator_var;
typedef AdapterActivator_var AdapterActivator_out;


// Common definitions for interface AdapterActivator
class AdapterActivator : virtual public CORBA::Object
{
  public:
    virtual ~AdapterActivator();
    static AdapterActivator_ptr _duplicate( AdapterActivator_ptr obj );
    static AdapterActivator_ptr _narrow( CORBA::Object_ptr obj );
    static AdapterActivator_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual CORBA::Boolean unknown_adapter( POA_ptr parent, const char* name ) = 0;
  protected:
    AdapterActivator() {};
  private:
    AdapterActivator( const AdapterActivator& );
    void operator=( const AdapterActivator& );
};


class ServantManager;
typedef ServantManager *ServantManager_ptr;
typedef ServantManager_ptr ServantManagerRef;
typedef ObjVar<ServantManager> ServantManager_var;
typedef ServantManager_var ServantManager_out;


// Common definitions for interface ServantManager
class ServantManager : virtual public CORBA::Object
{
  public:
    virtual ~ServantManager();
    static ServantManager_ptr _duplicate( ServantManager_ptr obj );
    static ServantManager_ptr _narrow( CORBA::Object_ptr obj );
    static ServantManager_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

  protected:
    ServantManager() {};
  private:
    ServantManager( const ServantManager& );
    void operator=( const ServantManager& );
};


class ServantActivator;
typedef ServantActivator *ServantActivator_ptr;
typedef ServantActivator_ptr ServantActivatorRef;
typedef ObjVar<ServantActivator> ServantActivator_var;
typedef ServantActivator_var ServantActivator_out;


// Common definitions for interface ServantActivator
class ServantActivator : 
  virtual public ::PortableServer::ServantManager
{
  public:
    virtual ~ServantActivator();
    static ServantActivator_ptr _duplicate( ServantActivator_ptr obj );
    static ServantActivator_ptr _narrow( CORBA::Object_ptr obj );
    static ServantActivator_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    virtual ::PortableServer::Servant incarnate( const ObjectId& oid, POA_ptr adapter ) = 0;
    virtual void etherealize( const ObjectId& oid, POA_ptr adapter, ::PortableServer::Servant serv, CORBA::Boolean cleanup_in_progress, CORBA::Boolean remaining_activations ) = 0;
  protected:
    ServantActivator() {};
  private:
    ServantActivator( const ServantActivator& );
    void operator=( const ServantActivator& );
};


class ServantLocator;
typedef ServantLocator *ServantLocator_ptr;
typedef ServantLocator_ptr ServantLocatorRef;
typedef ObjVar<ServantLocator> ServantLocator_var;
typedef ServantLocator_var ServantLocator_out;


// Common definitions for interface ServantLocator
class ServantLocator : 
  virtual public ::PortableServer::ServantManager
{
  public:
    virtual ~ServantLocator();
    static ServantLocator_ptr _duplicate( ServantLocator_ptr obj );
    static ServantLocator_ptr _narrow( CORBA::Object_ptr obj );
    static ServantLocator_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    // begin-idl-hack
    typedef void * Cookie;
    // end-idl-hack

    typedef char* Identifier;
    typedef CORBA::String_var Identifier_var;
    typedef CORBA::String_out Identifier_out;


    virtual ::PortableServer::Servant preinvoke( const ObjectId& oid, POA_ptr adapter, const char* operation, Cookie& the_cookie ) = 0;
    virtual void postinvoke( const ObjectId& oid, POA_ptr adapter, const char* operation, Cookie the_cookie, ::PortableServer::Servant the_servant ) = 0;
  protected:
    ServantLocator() {};
  private:
    ServantLocator( const ServantLocator& );
    void operator=( const ServantLocator& );
};



// Common definitions for interface POA
class POA : virtual public CORBA::Object
{
  public:
    virtual ~POA();
    static POA_ptr _duplicate( POA_ptr obj );
    static POA_ptr _narrow( CORBA::Object_ptr obj );
    static POA_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    // begin-idl-hack
    // begin-mico-extension
    static POA_ptr _the_root_poa;
    virtual CORBA::Object_ptr activate_for_this (PortableServer::Servant) = 0;
    virtual void poa_manager_callback (POAManager::POAManagerState,
				       CORBA::Boolean,
				       CORBA::Boolean) = 0;
    // end-mico-extension
    // end-idl-hack

    struct AdapterAlreadyExists : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      AdapterAlreadyExists();
      ~AdapterAlreadyExists();
      AdapterAlreadyExists( const AdapterAlreadyExists& s );
      AdapterAlreadyExists& operator=( const AdapterAlreadyExists& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static AdapterAlreadyExists *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<AdapterAlreadyExists> AdapterAlreadyExists_var;
    typedef AdapterAlreadyExists_var AdapterAlreadyExists_out;

    struct AdapterInactive : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      AdapterInactive();
      ~AdapterInactive();
      AdapterInactive( const AdapterInactive& s );
      AdapterInactive& operator=( const AdapterInactive& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static AdapterInactive *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<AdapterInactive> AdapterInactive_var;
    typedef AdapterInactive_var AdapterInactive_out;

    struct AdapterNonExistent : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      AdapterNonExistent();
      ~AdapterNonExistent();
      AdapterNonExistent( const AdapterNonExistent& s );
      AdapterNonExistent& operator=( const AdapterNonExistent& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static AdapterNonExistent *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<AdapterNonExistent> AdapterNonExistent_var;
    typedef AdapterNonExistent_var AdapterNonExistent_out;

    struct InvalidPolicy : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      InvalidPolicy();
      ~InvalidPolicy();
      InvalidPolicy( const InvalidPolicy& s );
      InvalidPolicy& operator=( const InvalidPolicy& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static InvalidPolicy *_narrow( CORBA::Exception *ex );
      CORBA::UShort index;
    };

    typedef ExceptVar<InvalidPolicy> InvalidPolicy_var;
    typedef InvalidPolicy_var InvalidPolicy_out;

    struct NoServant : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      NoServant();
      ~NoServant();
      NoServant( const NoServant& s );
      NoServant& operator=( const NoServant& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static NoServant *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<NoServant> NoServant_var;
    typedef NoServant_var NoServant_out;

    struct ObjectAlreadyActive : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      ObjectAlreadyActive();
      ~ObjectAlreadyActive();
      ObjectAlreadyActive( const ObjectAlreadyActive& s );
      ObjectAlreadyActive& operator=( const ObjectAlreadyActive& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static ObjectAlreadyActive *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<ObjectAlreadyActive> ObjectAlreadyActive_var;
    typedef ObjectAlreadyActive_var ObjectAlreadyActive_out;

    struct ObjectNotActive : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      ObjectNotActive();
      ~ObjectNotActive();
      ObjectNotActive( const ObjectNotActive& s );
      ObjectNotActive& operator=( const ObjectNotActive& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static ObjectNotActive *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<ObjectNotActive> ObjectNotActive_var;
    typedef ObjectNotActive_var ObjectNotActive_out;

    struct ServantAlreadyActive : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      ServantAlreadyActive();
      ~ServantAlreadyActive();
      ServantAlreadyActive( const ServantAlreadyActive& s );
      ServantAlreadyActive& operator=( const ServantAlreadyActive& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static ServantAlreadyActive *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<ServantAlreadyActive> ServantAlreadyActive_var;
    typedef ServantAlreadyActive_var ServantAlreadyActive_out;

    struct ServantNotActive : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      ServantNotActive();
      ~ServantNotActive();
      ServantNotActive( const ServantNotActive& s );
      ServantNotActive& operator=( const ServantNotActive& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static ServantNotActive *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<ServantNotActive> ServantNotActive_var;
    typedef ServantNotActive_var ServantNotActive_out;

    struct WrongAdapter : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      WrongAdapter();
      ~WrongAdapter();
      WrongAdapter( const WrongAdapter& s );
      WrongAdapter& operator=( const WrongAdapter& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static WrongAdapter *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<WrongAdapter> WrongAdapter_var;
    typedef WrongAdapter_var WrongAdapter_out;

    struct WrongPolicy : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      WrongPolicy();
      ~WrongPolicy();
      WrongPolicy( const WrongPolicy& s );
      WrongPolicy& operator=( const WrongPolicy& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static WrongPolicy *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<WrongPolicy> WrongPolicy_var;
    typedef WrongPolicy_var WrongPolicy_out;

    typedef char* RepositoryId;
    typedef CORBA::String_var RepositoryId_var;
    typedef CORBA::String_out RepositoryId_out;


    virtual char* the_name() = 0;
    virtual ::PortableServer::POA_ptr the_parent() = 0;
    virtual POAManager_ptr the_POAManager() = 0;
    virtual AdapterActivator_ptr the_activator() = 0;
    virtual void the_activator( AdapterActivator_ptr value ) = 0;
    virtual ::PortableServer::POA_ptr create_POA( const char* adapter_name, POAManager_ptr a_POAManager, const CORBA::PolicyList& policies ) = 0;
    virtual ::PortableServer::POA_ptr find_POA( const char* adapter_name, CORBA::Boolean activate_it ) = 0;
    virtual void destroy( CORBA::Boolean etherealize_objects, CORBA::Boolean wait_for_completion ) = 0;
    virtual ThreadPolicy_ptr create_thread_policy( ThreadPolicyValue value ) = 0;
    virtual LifespanPolicy_ptr create_lifespan_policy( LifespanPolicyValue value ) = 0;
    virtual IdUniquenessPolicy_ptr create_id_uniqueness_policy( IdUniquenessPolicyValue value ) = 0;
    virtual IdAssignmentPolicy_ptr create_id_assignment_policy( IdAssignmentPolicyValue value ) = 0;
    virtual ImplicitActivationPolicy_ptr create_implicit_activation_policy( ImplicitActivationPolicyValue value ) = 0;
    virtual ServantRetentionPolicy_ptr create_servant_retention_policy( ServantRetentionPolicyValue value ) = 0;
    virtual RequestProcessingPolicy_ptr create_request_processing_policy( RequestProcessingPolicyValue value ) = 0;
    virtual ServantManager_ptr get_servant_manager() = 0;
    virtual void set_servant_manager( ServantManager_ptr imgr ) = 0;
    virtual Servant get_servant() = 0;
    virtual void set_servant( Servant p_servant ) = 0;
    virtual ObjectId* activate_object( Servant p_servant ) = 0;
    virtual void activate_object_with_id( const ObjectId& id, Servant p_servant ) = 0;
    virtual void deactivate_object( const ObjectId& oid ) = 0;
    virtual CORBA::Object_ptr create_reference( const char* intf ) = 0;
    virtual CORBA::Object_ptr create_reference_with_id( const ObjectId& oid, const char* intf ) = 0;
    virtual ObjectId* servant_to_id( Servant p_servant ) = 0;
    virtual CORBA::Object_ptr servant_to_reference( Servant p_servant ) = 0;
    virtual Servant reference_to_servant( CORBA::Object_ptr reference ) = 0;
    virtual ObjectId* reference_to_id( CORBA::Object_ptr reference ) = 0;
    virtual Servant id_to_servant( const ObjectId& oid ) = 0;
    virtual CORBA::Object_ptr id_to_reference( const ObjectId& oid ) = 0;
  protected:
    POA() {};
  private:
    POA( const POA& );
    void operator=( const POA& );
};


class Current;
typedef Current *Current_ptr;
typedef Current_ptr CurrentRef;
typedef ObjVar<Current> Current_var;
typedef Current_var Current_out;


// Common definitions for interface Current
class Current : 
  virtual public ::CORBA::Current
{
  public:
    virtual ~Current();
    static Current_ptr _duplicate( Current_ptr obj );
    static Current_ptr _narrow( CORBA::Object_ptr obj );
    static Current_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );

    // begin-idl-hack
    // begin-mico-extension
    static Current_ptr _the_poa_current;
    virtual CORBA::Object_ptr make_ref () = 0;
    virtual CORBA::Boolean iscurrent () = 0;
    virtual PortableServer::Servant get_serv () = 0;
    // end-mico-extension
    // end-idl-hack

    struct NoContext : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      NoContext();
      ~NoContext();
      NoContext( const NoContext& s );
      NoContext& operator=( const NoContext& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      void _throwit() const;
      const char *_repoid() const;
      CORBA::Exception *_clone() const;
      static NoContext *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<NoContext> NoContext_var;
    typedef NoContext_var NoContext_out;

    virtual POA_ptr get_POA() = 0;
    virtual ObjectId* get_object_id() = 0;
  protected:
    Current() {};
  private:
    Current( const Current& );
    void operator=( const Current& );
};


#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_PortableServer)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif

// begin-idl-hack
/*
 * By specification, AdapterActivators and ServantManagers are Servant
 * implementations, not pseudo objects, that must be activated like any
 * other servant. This requires special handling.
 * Actually, we don't *require* that these objects are explicitely
 * activated, but we support their activation.
 */

#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL POA_PortableServer {
#endif
class AdapterActivator :
  virtual public PortableServer::DynamicImplementation,
  virtual public PortableServer::AdapterActivator
{
public:
  virtual ~AdapterActivator ();
  PortableServer::AdapterActivator_ptr _this ();
  bool _is_a (const char *);
  void invoke (CORBA::ServerRequest_ptr);
  CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &,
					  PortableServer::POA_ptr);

  void * _narrow_helper (const char *);
  static AdapterActivator * _narrow (CORBA::Object_ptr);
  static AdapterActivator * _narrow (PortableServer::Servant);
};

class ServantManager :
  virtual public PortableServer::DynamicImplementation,
  virtual public PortableServer::ServantManager
{
public:
  virtual ~ServantManager ();
  PortableServer::ServantManager_ptr _this ();
  bool _is_a (const char *);
  void invoke (CORBA::ServerRequest_ptr);
  CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &,
					  PortableServer::POA_ptr);

  void * _narrow_helper (const char *);
  static ServantManager * _narrow (CORBA::Object_ptr);
  static ServantManager * _narrow (PortableServer::Servant);
};

class ServantActivator :
  virtual public ServantManager,
  virtual public PortableServer::ServantActivator
{
public:
  virtual ~ServantActivator ();
  PortableServer::ServantActivator_ptr _this ();
  bool _is_a (const char *);
  void invoke (CORBA::ServerRequest_ptr);
  CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &,
					  PortableServer::POA_ptr);

  void * _narrow_helper (const char *);
  static ServantActivator * _narrow (CORBA::Object_ptr);
  static ServantActivator * _narrow (PortableServer::Servant);
};

class ServantLocator :
  virtual public ServantManager,
  virtual public PortableServer::ServantLocator
{
public:
  virtual ~ServantLocator ();
  PortableServer::ServantLocator_ptr _this ();
  bool _is_a (const char *);
  void invoke (CORBA::ServerRequest_ptr);
  CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &,
					  PortableServer::POA_ptr);

  void * _narrow_helper (const char *);
  static ServantLocator * _narrow (CORBA::Object_ptr);
  static ServantLocator * _narrow (PortableServer::Servant);
};
#ifndef MICO_NO_TOPLEVEL_MODULES
};
#endif
// end-idl-hack

// begin-idl-hack
template<class T>
class POA_Tie_Base
{
protected:
  T * ptr;
  PortableServer::POA_ptr poa;
  CORBA::Boolean rel;

  POA_Tie_Base () {}

public:
  POA_Tie_Base (T *t, PortableServer::POA_ptr _poa, CORBA::Boolean _rel)
  {
    ptr = t;
    poa = PortableServer::POA::_duplicate (_poa);
    rel = _rel;
  }

  virtual ~POA_Tie_Base ()
  {
    if (rel) delete ptr;
    CORBA::release (poa);
  }

  T * _tie_object ()
  {
    return ptr;
  }
  
  void _tied_object (T &t)
  {
    if (rel) delete ptr;
    ptr = &t;
    rel = 0;
  }

  CORBA::Boolean _is_owner ()
  {
    return rel;
  }

  void _is_owner (CORBA::Boolean _rel)
  {
    rel = _rel;
  }
};
// end-idl-hack



#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
