// -*- c++ -*-
/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#ifndef __mico_throw_h__
#define __mico_throw_h__

static void
mico_throw (const CORBA::Exception &_ex)
{
    // avoid compiler warnings ...
    (void)mico_throw;

    CORBA::SystemException *s;
    CORBA::UserException *u;
    CORBA::Exception *ex = (CORBA::Exception *)&_ex;
    ex->_prepare_throw ();

#ifdef HAVE_EXCEPTIONS
    if ((s = CORBA::SystemException::_narrow (ex)))
	throw CORBA::SystemException_var (
	    (CORBA::SystemException *)s->_clone());
    else if ((u = CORBA::UserException::_narrow (ex)))
	u->_throwit();
#endif
    CORBA::Exception::_throw_failed (ex);
}

inline void
CORBA::Exception::_raise ()
{
    ::mico_throw (*this);
}

static inline ostream &
operator<< (ostream &os, CORBA::Exception *ex)
{
    ex->_print (os);
    return os;
}

#endif // __mico_throw_h__
